package com.zipcodewilmington.phonebook;

import java.util.HashMap;
import java.util.Map;

import static javax.swing.UIManager.put;

/**
 * Created by leon on 1/23/18.
 * https://git.zipcode.rocks/Cohort4.2/CR-MicroLabs-Composition-PhoneBook
 */
public class PhoneBook {

    private HashMap<String, String> listings  = new HashMap<>();

    PhoneBook() {}

    public int getEntryCount() {
        return listings.size();
    }

    public boolean hasEntry(String name) {
        if (listings.get(name) == null) { return false; }
        return true;
    }

    public void  add(String name, String phoneNumber) {
//        adds an entry to the composite associate data type
        listings.put(name, phoneNumber);
    }

    public String lookup(String name) {
//        returns a phone number for the respective input name
        return listings.get(name);
    }

    public void remove(String name) {
//        removes an entry to the composite associate data type
        listings.remove(name);
    }

    public String reverseLookup(String phonenumber) {
//        returns a name for the respective input phoneNumber
        return listings.entrySet().stream()
                .filter(entry -> phonenumber.equals(entry.getValue()))
                .map(Map.Entry::getKey)
                .findFirst().get();
    }

    public void listNamesAndNumbers() {
//        return a human-readable list of all entries (names and phone numbers) in alphabetical order.
//        Format should be [name] [phone number]
        listings.forEach((k,v) -> System.out.println(k + " " + v));
    }
}