package com.zipcodewilmington.phonebook;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

/**
 * Created by leon on 1/23/18.
 * https://git.zipcode.rocks/Cohort4.2/CR-MicroLabs-Composition-PhoneBook
 */
public class PhoneBookTest {
    String testName;
    String testNumber;

    @Before
    public void setup() {
        testName = "Test Testmond";
        testNumber = "302-299-6553";
    }

    @Test
    public void  addTest() {
//        adds an entry to the composite associate data type
        PhoneBook app = new PhoneBook();

        double before = app.getEntryCount();

        app.add(testName, testNumber);

        double after = app.getEntryCount();

        Assert.assertTrue((before + 1) == after);
    }

    @Test
    public void hasEntryTest() {
        PhoneBook app = new PhoneBook();

        app.add(testName, testNumber);
        Assert.assertTrue(app.hasEntry(testName));
    }

    @Test
    public void lookupTest() {
        PhoneBook app = new PhoneBook();

        app.add(testName, testNumber);
        Assert.assertTrue(app.lookup(testName).equals(testNumber));
    }

    @Test
    public void removeTest() {
        PhoneBook app = new PhoneBook();
//        removes an entry to the composite associate data type
        app.add(testName, testNumber);
        app.remove(testName);
        Assert.assertFalse(app.hasEntry(testName));
    }

    @Test
    public void reverseLookupTest() {
        PhoneBook app = new PhoneBook();
//        returns a name for the respective input phoneNumber
        app.add(testName, testNumber);
        String entry = app.reverseLookup(testNumber);
        Assert.assertTrue(entry.equals((testName)));
    }

    @Test
    public void listNamesAndNumbersTest() {
        PhoneBook app = new PhoneBook();

//        return a human-readable list of all entries (names and phone numbers) in alphabetical order.
//        Format should be [name] [phone number]

//        System.out.println()
    }

}
